Index: include/avr/iotnx61.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotnx61.h,v
retrieving revision 1.7
diff -u -r1.7 iotnx61.h
--- include/avr/iotnx61.h	8 Sep 2008 16:46:58 -0000	1.7
+++ include/avr/iotnx61.h	26 Mar 2009 20:10:37 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2006, 2007 Anatoly Sokolov
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -439,77 +440,372 @@
 /* Interrupt vectors */
 /* Interrupt vector 0 is the reset vector. */
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* Pin Change Interrupt */
+#define PCINT_num 			2
 #define PCINT_vect			_VECTOR(2)
 #define SIG_PIN_CHANGE			_VECTOR(2)
 
 /* Timer/Counter1 Compare Match 1A */
+#define TIMER1_COMPA_num 		3
 #define TIMER1_COMPA_vect		_VECTOR(3)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(3)
 
 /* Timer/Counter1 Compare Match 1B */
+#define TIMER1_COMPB_num 		4
 #define TIMER1_COMPB_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(4)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			5
 #define TIMER1_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW1			_VECTOR(5)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			6
 #define TIMER0_OVF_vect			_VECTOR(6)
 #define SIG_OVERFLOW0			_VECTOR(6)
 
 /* USI Start */
+#define USI_START_num 			7
 #define USI_START_vect			_VECTOR(7)
 #define SIG_USI_START			_VECTOR(7)
 
 /* USI Overflow */
+#define USI_OVF_num 			8
 #define USI_OVF_vect			_VECTOR(8)
 #define SIG_USI_OVERFLOW		_VECTOR(8)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			9
 #define EE_RDY_vect			_VECTOR(9)
 #define SIG_EEPROM_READY		_VECTOR(9)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			10
 #define ANA_COMP_vect			_VECTOR(10)
 #define SIG_ANA_COMP			_VECTOR(10)
 #define SIG_COMPARATOR			_VECTOR(10)
 
 /* ADC Conversion Complete */
+#define ADC_num 			11
 #define ADC_vect			_VECTOR(11)
 #define SIG_ADC				_VECTOR(11)
 
 /* Watchdog Time-Out */
+#define WDT_num 			12
 #define WDT_vect			_VECTOR(12)
 #define SIG_WDT				_VECTOR(12)
 
 /* External Interrupt 1 */
+#define INT1_num 			13
 #define INT1_vect			_VECTOR(13)
 #define SIG_INTERRUPT1			_VECTOR(13)
 
 /* Timer/Counter0 Compare Match A */
+#define TIMER0_COMPA_num 		14
 #define TIMER0_COMPA_vect		_VECTOR(14)
 #define SIG_OUTPUT_COMPARE0A		_VECTOR(14)
 
 /* Timer/Counter0 Compare Match B */
+#define TIMER0_COMPB_num 		15
 #define TIMER0_COMPB_vect		_VECTOR(15)
 #define SIG_OUTPUT_COMPARE0B		_VECTOR(15)
 
 /* ADC Conversion Complete */
+#define TIMER0_CAPT_num 		16
 #define TIMER0_CAPT_vect		_VECTOR(16)
 #define SIG_INPUT_CAPTURE0		_VECTOR(16)
 
 /* Timer/Counter1 Compare Match D */
+#define TIMER1_COMPD_num 		17
 #define TIMER1_COMPD_vect		_VECTOR(17)
 #define SIG_OUTPUT_COMPARE0D		_VECTOR(17)
 
 /* Timer/Counter1 Fault Protection */
+#define FAULT_PROTECTION_num 		18
 #define FAULT_PROTECTION_vect		_VECTOR(18)
 
 #define _VECTORS_SIZE 38
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_DI  	DDRA
+#define PORT_DI 	PORTA
+#define PIN_DI  	PINA
+#define DI_IDX  	0
+
+#define DDR_SDA  	DDRA
+#define PORT_SDA 	PORTA
+#define PIN_SDA  	PINA
+#define SDA_IDX  	0
+
+#define DDR_PCINT0  	DDRA
+#define PORT_PCINT0 	PORTA
+#define PIN_PCINT0  	PINA
+#define PCINT0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_DO  	DDRA
+#define PORT_DO 	PORTA
+#define PIN_DO  	PINA
+#define DO_IDX  	1
+
+#define DDR_PCINT1  	DDRA
+#define PORT_PCINT1 	PORTA
+#define PIN_PCINT1  	PINA
+#define PCINT1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_INT1  	DDRA
+#define PORT_INT1 	PORTA
+#define PIN_INT1  	PINA
+#define INT1_IDX  	2
+
+#define DDR_USCK  	DDRA
+#define PORT_USCK 	PORTA
+#define PIN_USCK  	PINA
+#define USCK_IDX  	2
+
+#define DDR_SCL  	DDRA
+#define PORT_SCL 	PORTA
+#define PIN_SCL  	PINA
+#define SCL_IDX  	2
+
+#define DDR_PCINT2  	DDRA
+#define PORT_PCINT2 	PORTA
+#define PIN_PCINT2  	PINA
+#define PCINT2_IDX  	2
+
+#define DDR_PCINT3  	DDRA
+#define PORT_PCINT3 	PORTA
+#define PIN_PCINT3  	PINA
+#define PCINT3_IDX  	3
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	4
+
+#define DDR_ICP0  	DDRA
+#define PORT_ICP0 	PORTA
+#define PIN_ICP0  	PINA
+#define ICP0_IDX  	4
+
+#define DDR_PCINT4  	DDRA
+#define PORT_PCINT4 	PORTA
+#define PIN_PCINT4  	PINA
+#define PCINT4_IDX  	4
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	5
+
+#define DDR_AIN2  	DDRA
+#define PORT_AIN2 	PORTA
+#define PIN_AIN2  	PINA
+#define AIN2_IDX  	5
+
+#define DDR_PCINT5  	DDRA
+#define PORT_PCINT5 	PORTA
+#define PIN_PCINT5  	PINA
+#define PCINT5_IDX  	5
+
+#define DDR_ADC5  	DDRA
+#define PORT_ADC5 	PORTA
+#define PIN_ADC5  	PINA
+#define ADC5_IDX  	6
+
+#define DDR_AIN0  	DDRA
+#define PORT_AIN0 	PORTA
+#define PIN_AIN0  	PINA
+#define AIN0_IDX  	6
+
+#define DDR_PCINT6  	DDRA
+#define PORT_PCINT6 	PORTA
+#define PIN_PCINT6  	PINA
+#define PCINT6_IDX  	6
+
+#define DDR_ADC6  	DDRA
+#define PORT_ADC6 	PORTA
+#define PIN_ADC6  	PINA
+#define ADC6_IDX  	7
+
+#define DDR_AIN1  	DDRA
+#define PORT_AIN1 	PORTA
+#define PIN_AIN1  	PINA
+#define AIN1_IDX  	7
+
+#define DDR_PCINT7  	DDRA
+#define PORT_PCINT7 	PORTA
+#define PIN_PCINT7  	PINA
+#define PCINT7_IDX  	7
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	0
+
+#define DDR_DI  	DDRB
+#define PORT_DI 	PORTB
+#define PIN_DI  	PINB
+#define DI_IDX  	0
+
+#define DDR_SDA  	DDRB
+#define PORT_SDA 	PORTB
+#define PIN_SDA  	PINB
+#define SDA_IDX  	0
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	0
+
+#define DDR_PCINT8  	DDRB
+#define PORT_PCINT8 	PORTB
+#define PIN_PCINT8  	PINB
+#define PCINT8_IDX  	0
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	1
+
+#define DDR_DO  	DDRB
+#define PORT_DO 	PORTB
+#define PIN_DO  	PINB
+#define DO_IDX  	1
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	1
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	2
+
+#define DDR_USCK  	DDRB
+#define PORT_USCK 	PORTB
+#define PIN_USCK  	PINB
+#define USCK_IDX  	2
+
+#define DDR_SCL  	DDRB
+#define PORT_SCL 	PORTB
+#define PIN_SCL  	PINB
+#define SCL_IDX  	2
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	2
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	3
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_ADC7  	DDRB
+#define PORT_ADC7 	PORTB
+#define PIN_ADC7  	PINB
+#define ADC7_IDX  	4
+
+#define DDR_PCINT12  	DDRB
+#define PORT_PCINT12 	PORTB
+#define PIN_PCINT12  	PINB
+#define PCINT12_IDX  	4
+
+#define DDR_OC1D  	DDRB
+#define PORT_OC1D 	PORTB
+#define PIN_OC1D  	PINB
+#define OC1D_IDX  	4
+
+#define DDR_CLKI  	DDRB
+#define PORT_CLKI 	PORTB
+#define PIN_CLKI  	PINB
+#define CLKI_IDX  	4
+
+#define DDR_ADC8  	DDRB
+#define PORT_ADC8 	PORTB
+#define PIN_ADC8  	PINB
+#define ADC8_IDX  	5
+
+#define DDR_PCINT13  	DDRB
+#define PORT_PCINT13 	PORTB
+#define PIN_PCINT13  	PINB
+#define PCINT13_IDX  	5
+
+#define DDR_OC1D  	DDRB
+#define PORT_OC1D 	PORTB
+#define PIN_OC1D  	PINB
+#define OC1D_IDX  	5
+
+#define DDR_CKLO  	DDRB
+#define PORT_CKLO 	PORTB
+#define PIN_CKLO  	PINB
+#define CKLO_IDX  	5
+
+#define DDR_ADC9  	DDRB
+#define PORT_ADC9 	PORTB
+#define PIN_ADC9  	PINB
+#define ADC9_IDX  	6
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	6
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	6
+
+#define DDR_PCINT14  	DDRB
+#define PORT_PCINT14 	PORTB
+#define PIN_PCINT14  	PINB
+#define PCINT14_IDX  	6
+
+#define DDR_ADC10  	DDRB
+#define PORT_ADC10 	PORTB
+#define PIN_ADC10  	PINB
+#define ADC10_IDX  	7
+
+#define DDR_PCINT15  	DDRB
+#define PORT_PCINT15 	PORTB
+#define PIN_PCINT15  	PINB
+#define PCINT15_IDX  	7
+
+
 #endif  /* _AVR_IOTNx61_H_ */
Index: include/avr/iotn12.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotn12.h,v
retrieving revision 1.15
diff -u -r1.15 iotn12.h
--- include/avr/iotn12.h	17 Oct 2008 23:22:44 -0000	1.15
+++ include/avr/iotn12.h	26 Mar 2009 20:10:35 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002,2005 Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -124,23 +125,28 @@
 /* Interrupt vectors */
 
 /* External Interrupt 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 0 */
+#define IO_PINS_num 			2
 #define IO_PINS_vect			_VECTOR(2)
 #define SIG_PIN				_VECTOR(2)
 #define SIG_PIN_CHANGE			_VECTOR(2)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			3
 #define TIMER0_OVF_vect			_VECTOR(3)
 #define SIG_OVERFLOW0			_VECTOR(3)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			4
 #define EE_RDY_vect			_VECTOR(4)
 #define SIG_EEPROM_READY		_VECTOR(4)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			5
 #define ANA_COMP_vect			_VECTOR(5)
 #define SIG_COMPARATOR			_VECTOR(5)
 
@@ -262,4 +268,36 @@
 #define SIGNATURE_2 0x05
 
 
+/* Device Pin Definitions */
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	0
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	1
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	1
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	2
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	2
+
+#define DDR_CLOCK  	DDRB
+#define PORT_CLOCK 	PORTB
+#define PIN_CLOCK  	PINB
+#define CLOCK_IDX  	3
+
+
 #endif /* _AVR_IOTN12_H_ */
Index: include/avr/iotnx4.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iotnx4.h,v
retrieving revision 1.6
diff -u -r1.6 iotnx4.h
--- include/avr/iotnx4.h	7 Feb 2009 19:24:23 -0000	1.6
+++ include/avr/iotnx4.h	26 Mar 2009 20:10:36 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2005,2007 Anatoly Sokolov
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -384,73 +385,290 @@
 /* Interrupt vectors */
 /* Interrupt vector 0 is the reset vector. */
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
+#define EXT_INT0_num 			1
 #define EXT_INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* Pin Change Interrupt Request 0 */
+#define PCINT0_num 			2
 #define PCINT0_vect			_VECTOR(2)
 #define SIG_PIN_CHANGE0			_VECTOR(2)
 
 /* Pin Change Interrupt Request 1 */
+#define PCINT1_num 			3
 #define PCINT1_vect			_VECTOR(3)
 #define SIG_PIN_CHANGE1			_VECTOR(3)
 
 /* Watchdog Time-out */
+#define WDT_num 			4
 #define WDT_vect			_VECTOR(4)
+#define WATCHDOG_num 			4
 #define WATCHDOG_vect			_VECTOR(4)
 #define SIG_WATCHDOG_TIMEOUT		_VECTOR(4)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		5
 #define TIMER1_CAPT_vect		_VECTOR(5)
+#define TIM1_CAPT_num 			5
 #define TIM1_CAPT_vect			_VECTOR(5)
 #define SIG_INPUT_CAPTURE1		_VECTOR(5)
 
 /* Timer/Counter1 Compare Match A */
+#define TIM1_COMPA_num 			6
 #define TIM1_COMPA_vect			_VECTOR(6)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(6)
 
 /* Timer/Counter1 Compare Match B */
+#define TIM1_COMPB_num 			7
 #define TIM1_COMPB_vect			_VECTOR(7)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(7)
 
 /* Timer/Counter1 Overflow */
+#define TIM1_OVF_num 			8
 #define TIM1_OVF_vect			_VECTOR(8)
 #define SIG_OVERFLOW1			_VECTOR(8)
 
 /* Timer/Counter0 Compare Match A */
+#define TIM0_COMPA_num 			9
 #define TIM0_COMPA_vect			_VECTOR(9)
 #define SIG_OUTPUT_COMPARE0A		_VECTOR(9)
 
 /* Timer/Counter0 Compare Match B */
+#define TIM0_COMPB_num 			10
 #define TIM0_COMPB_vect			_VECTOR(10)
 #define SIG_OUTPUT_COMPARE0B		_VECTOR(10)
 
 /* Timer/Counter0 Overflow */
+#define TIM0_OVF_num 			11
 #define TIM0_OVF_vect			_VECTOR(11)
 #define SIG_OVERFLOW0			_VECTOR(11)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			12
 #define ANA_COMP_vect			_VECTOR(12)
 #define SIG_COMPARATOR			_VECTOR(12)
 
 /* ADC Conversion Complete */
+#define ADC_num 			13
 #define ADC_vect			_VECTOR(13)
 #define SIG_ADC				_VECTOR(13)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			14
 #define EE_RDY_vect			_VECTOR(14)
 #define SIG_EEPROM_READY		_VECTOR(14)
 
 /* USI START */
+#define USI_START_num 			15
 #define USI_START_vect			_VECTOR(15)
+#define USI_STR_num 			15
 #define USI_STR_vect			_VECTOR(15)
 #define SIG_USI_START			_VECTOR(15)
 
 /* USI Overflow */
+#define USI_OVF_num 			16
 #define USI_OVF_vect			_VECTOR(16)
 #define SIG_USI_OVERFLOW		_VECTOR(16)
 
 #define _VECTORS_SIZE 34
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_PCINT0  	DDRA
+#define PORT_PCINT0 	PORTA
+#define PIN_PCINT0  	PINA
+#define PCINT0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_AIN0  	DDRA
+#define PORT_AIN0 	PORTA
+#define PIN_AIN0  	PINA
+#define AIN0_IDX  	1
+
+#define DDR_PCINT1  	DDRA
+#define PORT_PCINT1 	PORTA
+#define PIN_PCINT1  	PINA
+#define PCINT1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_AIN1  	DDRA
+#define PORT_AIN1 	PORTA
+#define PIN_AIN1  	PINA
+#define AIN1_IDX  	2
+
+#define DDR_PCINT2  	DDRA
+#define PORT_PCINT2 	PORTA
+#define PIN_PCINT2  	PINA
+#define PCINT2_IDX  	2
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	3
+
+#define DDR_T0  	DDRA
+#define PORT_T0 	PORTA
+#define PIN_T0  	PINA
+#define T0_IDX  	3
+
+#define DDR_PCINT3  	DDRA
+#define PORT_PCINT3 	PORTA
+#define PIN_PCINT3  	PINA
+#define PCINT3_IDX  	3
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	4
+
+#define DDR_USCK  	DDRA
+#define PORT_USCK 	PORTA
+#define PIN_USCK  	PINA
+#define USCK_IDX  	4
+
+#define DDR_SCL  	DDRA
+#define PORT_SCL 	PORTA
+#define PIN_SCL  	PINA
+#define SCL_IDX  	4
+
+#define DDR_T1  	DDRA
+#define PORT_T1 	PORTA
+#define PIN_T1  	PINA
+#define T1_IDX  	4
+
+#define DDR_PCINT4  	DDRA
+#define PORT_PCINT4 	PORTA
+#define PIN_PCINT4  	PINA
+#define PCINT4_IDX  	4
+
+#define DDR_ADC5  	DDRA
+#define PORT_ADC5 	PORTA
+#define PIN_ADC5  	PINA
+#define ADC5_IDX  	5
+
+#define DDR_DO  	DDRA
+#define PORT_DO 	PORTA
+#define PIN_DO  	PINA
+#define DO_IDX  	5
+
+#define DDR_MISO  	DDRA
+#define PORT_MISO 	PORTA
+#define PIN_MISO  	PINA
+#define MISO_IDX  	5
+
+#define DDR_OC1B  	DDRA
+#define PORT_OC1B 	PORTA
+#define PIN_OC1B  	PINA
+#define OC1B_IDX  	5
+
+#define DDR_PCINT5  	DDRA
+#define PORT_PCINT5 	PORTA
+#define PIN_PCINT5  	PINA
+#define PCINT5_IDX  	5
+
+#define DDR_PCINT6  	DDRA
+#define PORT_PCINT6 	PORTA
+#define PIN_PCINT6  	PINA
+#define PCINT6_IDX  	6
+
+#define DDR_OC1A  	DDRA
+#define PORT_OC1A 	PORTA
+#define PIN_OC1A  	PINA
+#define OC1A_IDX  	6
+
+#define DDR_DI  	DDRA
+#define PORT_DI 	PORTA
+#define PIN_DI  	PINA
+#define DI_IDX  	6
+
+#define DDR_SDA  	DDRA
+#define PORT_SDA 	PORTA
+#define PIN_SDA  	PINA
+#define SDA_IDX  	6
+
+#define DDR_MOSI  	DDRA
+#define PORT_MOSI 	PORTA
+#define PIN_MOSI  	PINA
+#define MOSI_IDX  	6
+
+#define DDR_ADC6  	DDRA
+#define PORT_ADC6 	PORTA
+#define PIN_ADC6  	PINA
+#define ADC6_IDX  	6
+
+#define DDR_PCINT7  	DDRA
+#define PORT_PCINT7 	PORTA
+#define PIN_PCINT7  	PINA
+#define PCINT7_IDX  	7
+
+#define DDR_ICP1  	DDRA
+#define PORT_ICP1 	PORTA
+#define PIN_ICP1  	PINA
+#define ICP1_IDX  	7
+
+#define DDR_OC0B  	DDRA
+#define PORT_OC0B 	PORTA
+#define PIN_OC0B  	PINA
+#define OC0B_IDX  	7
+
+#define DDR_ADC7  	DDRA
+#define PORT_ADC7 	PORTA
+#define PIN_ADC7  	PINA
+#define ADC7_IDX  	7
+
+#define DDR_PCINT8  	DDRB
+#define PORT_PCINT8 	PORTB
+#define PIN_PCINT8  	PINB
+#define PCINT8_IDX  	0
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_INT0  	DDRB
+#define PORT_INT0 	PORTB
+#define PIN_INT0  	PINB
+#define INT0_IDX  	2
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	2
+
+#define DDR_CKOUT  	DDRB
+#define PORT_CKOUT 	PORTB
+#define PIN_CKOUT  	PINB
+#define CKOUT_IDX  	2
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_dW  	DDRB
+#define PORT_dW 	PORTB
+#define PIN_dW  	PINB
+#define dW_IDX  	3
+
+
 #endif /* _AVR_IOTNX4_H_ */
Index: include/avr/iom32.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom32.h,v
retrieving revision 1.17
diff -u -r1.17 iom32.h
--- include/avr/iom32.h	11 Feb 2009 17:53:36 -0000	1.17
+++ include/avr/iom32.h	26 Mar 2009 20:10:28 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Steinar Haugen
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -171,85 +172,105 @@
 /* Interrupt vectors */
 
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* External Interrupt Request 2 */
+#define INT2_num 			3
 #define INT2_vect			_VECTOR(3)
 #define SIG_INTERRUPT2			_VECTOR(3)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		4
 #define TIMER2_COMP_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(4)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			5
 #define TIMER2_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW2			_VECTOR(5)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		6
 #define TIMER1_CAPT_vect		_VECTOR(6)
 #define SIG_INPUT_CAPTURE1		_VECTOR(6)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		7
 #define TIMER1_COMPA_vect		_VECTOR(7)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(7)
 
 /* Timer/Counter1 Compare Match B */
+#define TIMER1_COMPB_num 		8
 #define TIMER1_COMPB_vect		_VECTOR(8)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(8)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			9
 #define TIMER1_OVF_vect			_VECTOR(9)
 #define SIG_OVERFLOW1			_VECTOR(9)
 
 /* Timer/Counter0 Compare Match */
+#define TIMER0_COMP_num 		10
 #define TIMER0_COMP_vect		_VECTOR(10)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(10)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			11
 #define TIMER0_OVF_vect			_VECTOR(11)
 #define SIG_OVERFLOW0			_VECTOR(11)
 
 /* Serial Transfer Complete */
+#define SPI_STC_num 			12
 #define SPI_STC_vect			_VECTOR(12)
 #define SIG_SPI				_VECTOR(12)
 
 /* USART, Rx Complete */
+#define USART_RXC_num 			13
 #define USART_RXC_vect			_VECTOR(13)
 #define SIG_USART_RECV			_VECTOR(13)
 #define SIG_UART_RECV			_VECTOR(13)
 
 /* USART Data Register Empty */
+#define USART_UDRE_num 			14
 #define USART_UDRE_vect			_VECTOR(14)
 #define SIG_USART_DATA			_VECTOR(14)
 #define SIG_UART_DATA			_VECTOR(14)
 
 /* USART, Tx Complete */
+#define USART_TXC_num 			15
 #define USART_TXC_vect			_VECTOR(15)
 #define SIG_USART_TRANS			_VECTOR(15)
 #define SIG_UART_TRANS			_VECTOR(15)
 
 /* ADC Conversion Complete */
+#define ADC_num 			16
 #define ADC_vect			_VECTOR(16)
 #define SIG_ADC				_VECTOR(16)
 
 /* EEPROM Ready */
+#define EE_RDY_num 			17
 #define EE_RDY_vect			_VECTOR(17)
 #define SIG_EEPROM_READY		_VECTOR(17)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			18
 #define ANA_COMP_vect			_VECTOR(18)
 #define SIG_COMPARATOR			_VECTOR(18)
 
 /* 2-wire Serial Interface */
+#define TWI_num 			19
 #define TWI_vect			_VECTOR(19)
 #define SIG_2WIRE_SERIAL		_VECTOR(19)
 
 /* Store Program Memory Ready */
+#define SPM_RDY_num 			20
 #define SPM_RDY_vect			_VECTOR(20)
 #define SIG_SPM_READY			_VECTOR(20)
 
@@ -693,4 +714,146 @@
 #define SIGNATURE_2 0x02
 
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	4
+
+#define DDR_ADc5  	DDRA
+#define PORT_ADc5 	PORTA
+#define PIN_ADc5  	PINA
+#define ADc5_IDX  	5
+
+#define DDR_ADC6  	DDRA
+#define PORT_ADC6 	PORTA
+#define PIN_ADC6  	PINA
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRA
+#define PORT_ADC7 	PORTA
+#define PIN_ADC7  	PINA
+#define ADC7_IDX  	7
+
+#define DDR_XCK  	DDRB
+#define PORT_XCK 	PORTB
+#define PIN_XCK  	PINB
+#define XCK_IDX  	0
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	0
+
+#define DDR_T1  	DDRB
+#define PORT_T1 	PORTB
+#define PIN_T1  	PINB
+#define T1_IDX  	1
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_INT2  	DDRB
+#define PORT_INT2 	PORTB
+#define PIN_INT2  	PINB
+#define INT2_IDX  	2
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_OC0  	DDRB
+#define PORT_OC0 	PORTB
+#define PIN_OC0  	PINB
+#define OC0_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_SCL  	DDRC
+#define PORT_SCL 	PORTC
+#define PIN_SCL  	PINC
+#define SCL_IDX  	0
+
+#define DDR_SDA  	DDRC
+#define PORT_SDA 	PORTC
+#define PIN_SDA  	PINC
+#define SDA_IDX  	1
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_OC1B  	DDRD
+#define PORT_OC1B 	PORTD
+#define PIN_OC1B  	PIND
+#define OC1B_IDX  	4
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_ICP  	DDRD
+#define PORT_ICP 	PORTD
+#define PIN_ICP  	PIND
+#define ICP_IDX  	6
+
+#define DDR_OC2  	DDRD
+#define PORT_OC2 	PORTD
+#define PIN_OC2  	PIND
+#define OC2_IDX  	7
+
+
 #endif /* _AVR_IOM32_H_ */
